import org.junit.jupiter.api.Assertions;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.List;

class AnalyticsTest {
    // Добавьте библиотеку CompanyCoreLib.jar участника в зависимости модуля проекта.
    // Например, в IntelliJ IDEA: Project Structure -> Modules -> Dependencies.
    // Затем можно приступать к запуску тестов.
    private Analytics classAnalytics = new Analytics();

    //<editor-fold desc="Easy Test Methods">
    @org.junit.jupiter.api.Test
    void popularMonths_Easy_01() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Easy_01.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Easy_01.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Easy_02() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Easy_02.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Easy_02.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Easy_03() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Easy_03.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Easy_03.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Easy_04() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Easy_04.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Easy_04.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Easy_05() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Easy_05.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Easy_05.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Easy_06() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Easy_06.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Easy_06.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Easy_07() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Easy_07.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Easy_07.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Easy_08() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Easy_08.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Easy_08.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Easy_09() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Easy_09.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Easy_09.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Easy_10() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Easy_10.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Easy_10.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Easy_11() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Easy_11.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Easy_11.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Easy_12() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Easy_12.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Easy_12.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Easy_13() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Easy_13.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Easy_13.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Easy_14() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Easy_14.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Easy_14.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Easy_15() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Easy_15.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Easy_15.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Easy_16() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Easy_16.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Easy_16.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Easy_17() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Easy_17.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Easy_17.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Easy_18() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Easy_18.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Easy_18.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Easy_19() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Easy_19.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Easy_19.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Easy_20() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Easy_20.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Easy_20.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }
    //</editor-fold>

    //<editor-fold desc="Hard Test Methods">
    @org.junit.jupiter.api.Test
    void popularMonths_Hard_01() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Hard_01.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Hard_01.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Hard_02() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Hard_02.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Hard_02.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Hard_03() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Hard_03.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Hard_03.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Hard_04() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Hard_04.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Hard_04.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Hard_05() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Hard_05.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Hard_05.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Hard_06() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Hard_06.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Hard_06.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Hard_07() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Hard_07.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Hard_07.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Hard_08() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Hard_08.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Hard_08.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Hard_09() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Hard_09.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Hard_09.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }

    @org.junit.jupiter.api.Test
    void popularMonths_Hard_10() throws FileNotFoundException {
        // Arrange
        ArrayList<LocalDateTime> listDates = readTestingData("InputData_Hard_10.txt");
        ArrayList<LocalDateTime> expected = readTestingData("OutputData_Hard_10.txt");

        // Act
        ArrayList<LocalDateTime> actual=classAnalytics.popularMonths(listDates);

        // Assert
        Assertions.assertTrue(expected.equals(actual));
    }
    //</editor-fold>

    private ArrayList<LocalDateTime> readTestingData(String fileName) throws FileNotFoundException {
        String path = "../TestingData/" + fileName;

        List<String> lines = new ArrayList<>();
        try
        {
            lines = Files.readAllLines(Paths.get(path), StandardCharsets.UTF_8);
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }

        ArrayList<LocalDateTime> listData=new ArrayList<>();
        for (String item :
                lines) {
            listData.add(LocalDateTime.parse(item, DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss")));
        }

        return listData;
    }
}